export class AnalyticalWorkspaceDecorator {
    workspace;
    decorated;
    factories;
    constructor(decorated, factories) {
        this.decorated = decorated;
        this.factories = factories;
        this.workspace = decorated.workspace;
    }
    getDescriptor(includeParentPrefixes) {
        return this.decorated.getDescriptor(includeParentPrefixes);
    }
    updateDescriptor(descriptor) {
        return this.decorated.updateDescriptor(descriptor);
    }
    getParentWorkspace() {
        return this.decorated.getParentWorkspace();
    }
    attributes() {
        const { attributes } = this.factories;
        if (attributes) {
            return attributes(this.decorated.attributes(), this.workspace);
        }
        return this.decorated.attributes();
    }
    execution() {
        const { execution } = this.factories;
        if (execution) {
            return execution(this.decorated.execution());
        }
        return this.decorated.execution();
    }
    catalog() {
        const { catalog } = this.factories;
        if (catalog) {
            return catalog(this.decorated.catalog());
        }
        return this.decorated.catalog();
    }
    measures() {
        return this.decorated.measures();
    }
    facts() {
        return this.decorated.facts();
    }
    insights() {
        return this.decorated.insights();
    }
    dashboards() {
        const { dashboards } = this.factories;
        if (dashboards) {
            return dashboards(this.decorated.dashboards(), this.workspace);
        }
        return this.decorated.dashboards();
    }
    settings() {
        const { workspaceSettings } = this.factories;
        if (workspaceSettings) {
            return workspaceSettings(this.decorated.settings(), this.workspace);
        }
        return this.decorated.settings();
    }
    styling() {
        return this.decorated.styling();
    }
    datasets() {
        return this.decorated.datasets();
    }
    permissions() {
        return this.decorated.permissions();
    }
    users() {
        return this.decorated.users();
    }
    dateFilterConfigs() {
        return this.decorated.dateFilterConfigs();
    }
    userGroups() {
        return this.decorated.userGroups();
    }
    accessControl() {
        return this.decorated.accessControl();
    }
    attributeHierarchies() {
        return this.decorated.attributeHierarchies();
    }
    exportDefinitions() {
        return this.decorated.exportDefinitions();
    }
    dataFilters() {
        return this.decorated.dataFilters();
    }
    logicalModel() {
        return this.decorated.logicalModel();
    }
    automations() {
        const { automations } = this.factories;
        if (automations) {
            return automations(this.decorated.automations(), this.workspace);
        }
        return this.decorated.automations();
    }
    genAI() {
        return this.decorated.genAI();
    }
}
//# sourceMappingURL=analyticalWorkspace.js.map